(function() {

    'use strict';

    app.controller('LoginCtrl', LoginCtrl);

    LoginCtrl.$inject = ['$scope', '$rootScope', '$state', 'Auth'];

    function LoginCtrl($scope, $rootScope, $state, Auth) {

        var vm = this;
        vm.data = {};
        vm.state = $state;
        vm.root = $rootScope;
        vm.user = null;
        vm.logout = Auth.logout;
        vm.isAuthorized = false;
        
        vm.activate = function () {
            
        }

        vm.login = function() {
        	Auth.loginWithProvider('google').then(function(authData){
                console.log('We are logged in!', authData);
            }).catch(function(error) {
                console.error(error);
            });
        }

        Auth.onAuth(function(authData) {
            vm.user = authData;
            if (authData != null) {
                vm.isAuthorized = true;
            } else {
                vm.isAuthorized = false;
            }
        });

        vm.activate();

    }

})();