app.factory('Auth', function($firebaseAuth, Root, $timeout) {

  var auth = $firebaseAuth(Root);

  return {

    loginWithProvider: function loginWithProvider() {
      return auth.$authWithOAuthPopup('google');
    },
    
    logout: function logout() {
      auth.$unauth();
    },
    
    onAuth: function onLoggedIn(callback) {

      auth.$onAuth(function(authData) {

        $timeout(function() {
          callback(authData);
        });

      });

    }

  };

});